<?php

namespace App\Http\Controllers;

use App\Models\ImagenMensaje;
use App\Models\LogBandeja;
use App\Models\Mapa;
use App\Models\Mensaje;
use App\Models\Vigilante;
use Carbon\Carbon;
use Exception;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Response;


class WebServicesController extends Controller
{
    public function __construct()
    {

    }

    // data request (idVigilante, idGrupo, mensaje , latitud , longitud, imagen,direccionGoogle, referencias)
    public function store_mensaje_app(Request $request)
    {
        try {

            $idVigilante        = $request->input('idVigilante');
            $idGrupo            = $request->input('idGrupo');
            $msj                = $request->input('mensaje');
            $latitud            = $request->input('latitud');
            $longitud           = $request->input('longitud');
            $direccionGoogle    = $request->input('direccionGoogle');
            $referencias        = $request->input('referencias');
            $emergencia         = $request->input('emergencia');




            $vigilante          = Vigilante::find($idVigilante);

            $mensaje = new Mensaje();
            $mensaje->idVigilante        = $vigilante->idVigilante;
            $mensaje->idEstadoMensaje    = 1;
            $mensaje->idGrupo            = $idGrupo;
            $mensaje->numeroCelular      = $vigilante->numeroCelular;
            $mensaje->mensaje            = $msj;
            $mensaje->fechaRegistro      = Carbon::now();
            $mensaje->folio              = date('ymdHis-u');
            $mensaje->emergencia         = $emergencia;
            $mensaje->calificacion       = 0;
            $mensaje->conclusionPositiva = 0;
            $mensaje->idMensajePrueba    = 0;
            $mensaje->seImprime          = 0;
            $mensaje->relevante          = 0;
            $mensaje->eliminado          = 0;
            $mensaje->save();

            $mapa   = new Mapa();
            $mapa->idMensaje        = $mensaje->idMensaje;
            $mapa->latitud          = $latitud;
            $mapa->longitud         = $longitud;
            $mapa->altitud          = '0';
            $mapa->mapa             = 'sinubicacion.jpg';
            $mapa->direccionGoogle  = strval($direccionGoogle);
            $mapa->theGeom          = null;
            $mapa->idCalle1         = 0;
            $mapa->idCalle2         = 0;
            $mapa->idCalle3         = 0;
            $mapa->referencias      = strval($referencias);
            $mapa->save();


            $namePhoto             = 'sin_foto.png';
            if($mensaje->emergencia == 1){
                $namePhoto             = 'emergencia.gif';
            }

            else{
                if($request->has('imagen')){

                    $imagen             = $request->input('imagen');
                    $imgdata            = base64_decode($imagen);
                    $namePhoto          = $this->setImageName($mensaje->idMensaje);

                    $namePhotoWithPath  = public_path() . '/imagenesmensajes/'.$namePhoto;

                    $handle = fopen($namePhotoWithPath, "wb");
                    fwrite($handle, $imgdata);
                    fclose($handle);

                }
            }



            $imagen                 = new ImagenMensaje();
            $imagen->idMensaje      = $mensaje->idMensaje;
            $imagen->imagen         = $namePhoto;
            $imagen->save();


            $mensajeJson = Mensaje::getMensajesByIDMensajeForBandeja($mensaje->idMensaje);

            $logBandeja                  = new LogBandeja();
            $logBandeja->idGrupo         = $idGrupo;
            $logBandeja->idEstadoMensaje = 1;
            $logBandeja->idUsuarioLog    = 0;
            $logBandeja->idMensaje       = $mensaje->idMensaje;
            $logBandeja->fechaRegistro   = date('Y-m-d H:i:s');
            $logBandeja->mensajeJson     = '['.json_encode($mensajeJson).']';
            $logBandeja->jsonDisponible  = '-';
            $logBandeja->save();


            $response = array(
                'status'        => 'success',
                'idMensaje'     => $mensaje->idMesaje,
                'folio'         => $mensaje->folio,
            );

        }
        catch (\Exception $e)
        {
            $response = array(
                'status'     => 'error',
                'msj'      =>  $e->getMessage()
            );
        }

        return Response::json($response);

    }

    public function getMensajeByIDMensaje($idMensaje)
    {
        try {

            $mensaje = Mensaje::getMensajeByIDMensajeForWebService($idMensaje);

            $response = array(
                'status'        => 'success',
                'mensaje'        => $mensaje
            );

        }
        catch (\Exception $e)
        {
            $response = array(
                'status'     => 'error',
                'error'      =>  $e->getMessage()
            );
        }

        return Response::json($response);
    }

    public function getMensajesByIDVigilanteIDGrupo($idVigilante,$idGrupo)
    {
        try {

            $mensajes = Mensaje::getMensajesByIDVigilanteIDGrupoForWebServices($idVigilante,$idGrupo);


            $response = array(
                'status'        => 'success',
                'mensajes'        => $mensajes
            );

        }
        catch (\Exception $e)
        {
            $response = array(
                'status'     => 'error',
                'error'      =>  $e->getMessage()
            );
        }

        return Response::json($response);


    }

    private function setImageName($idMensaje)
    {
       $name =   'msj_'.$idMensaje.'_'. Carbon::now()->format('YmdHis') . '_' . rand(1, 100) . '.jpg';

        return $name;
    }

}
