<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\DB;

class Mensaje extends Model
{
    use HasFactory;

    protected $table = 'tbl_mensajes';
    protected $primaryKey = 'idMensaje';

    protected $fillable = [

    ];



    public static function getMensajesByIDRol($idrol, $veremergencias)
    {
        $data = DB::table('tbl_mensajes')
            ->join('tbl_mapas', 'tbl_mapas.idMensaje','=', 'tbl_mensajes.idMensaje')
            //->join('cat_estados_mensajes', 'cat_estados_mensajes.idEstadoMensaje','=', 'tbl_mensajes.idEstadoMensaje')
            ->join('cat_vigilantes','cat_vigilantes.idVigilante', '=', 'tbl_mensajes.idVigilante')
            //->join('tbl_vigilantes_grupos', 'tbl_vigilantes_grupos.idVigilante', '=', 'tbl_mensajes.idVigilante')
            //->join('cat_grupos','cat_grupos.idGrupo', '=', 'tbl_vigilantes_grupos.idGrupo')
            ->join('cat_grupos','cat_grupos.idGrupo', '=', 'tbl_mensajes.idGrupo')
            ->join('cat_municipios','cat_municipios.idMunicipio', '=', 'cat_grupos.idMunicipio')
            ->join('tbl_grupos_rol', function($join) use($idrol) {
                $join->on('tbl_grupos_rol.idGrupo', '=', 'tbl_mensajes.idGrupo')
                    ->where('tbl_grupos_rol.idRol', '=', $idrol);
            })
            ->join('cat_roles', 'cat_roles.idRol','=', 'tbl_grupos_rol.idRol')

            //->leftJoin('tbl_log_bandeja', 'tbl_log_bandeja.idMensaje','=', 'tbl_mensajes.idMensaje')
            //->leftJoin('cat_usuarios', 'cat_usuarios.idUsuario','=', 'tbl_log_bandeja.idUsuarioLog')
            ->leftJoin('tbl_log_bandeja', function ($leftJoin) {
                $leftJoin->on('tbl_log_bandeja.idMensaje', '=', 'tbl_mensajes.idMensaje')
                    ->leftJoin('cat_usuarios', 'cat_usuarios.idUsuario','=', 'tbl_log_bandeja.idUsuarioLog')
                    ->where('tbl_log_bandeja.idLogBandeja', '=', DB::raw("(select max(t2.idLogBandeja) from tbl_log_bandeja as t2 where t2.idMensaje = tbl_mensajes.idMensaje)"));
            })

            ->select(
                'tbl_mensajes.idMensaje as idmensaje',
                'tbl_mensajes.idEstadoMensaje as idestado',
                'tbl_mensajes.mensaje',
                'tbl_mensajes.numeroCelular as numerocelular',
                'tbl_mensajes.mensaje',
                DB::Raw("DATE_FORMAT(tbl_mensajes.fechaRegistro, '%d/%m/%Y %H:%i:%s') as fecharegistro"),
                'tbl_mensajes.folio',
                //'tbl_mensajes.imagen',
                DB::Raw("(select imagen from tbl_imagenes_mensaje where tbl_imagenes_mensaje.idMensaje = tbl_mensajes.idMensaje limit 1) as imagen"),
                'tbl_mensajes.emergencia',

                'tbl_mapas.latitud',
                'tbl_mapas.longitud',
                DB::RAW("IFNULL(tbl_mapas.direccionGoogle,'') as dirGoogle"),

                DB::RAW("CONCAT(cat_vigilantes.nombre, ' ', IFNULL(cat_vigilantes.apellidoPaterno,''), IFNULL(cat_vigilantes.apellidoMaterno,'')) as nombrecompleto"),

                //'cat_estados_mensajes.estadoMensaje as estadomensaje',

                'cat_grupos.siglas as siglasgrupo',
                'cat_municipios.municipio',
                DB::Raw("'0' as idColonia"),
                DB::Raw("'' as colonia"),
                //'tbl_vigilantes_grupos.idgrupo',
                'tbl_mensajes.idGrupo as idgrupo',

                //DB::Raw("'' as idUsuarioLog"),
                //DB::Raw("'' as nombreUsuario"),
                //DB::Raw("IFNULL((select idUsuarioLog from tbl_log_bandeja where tbl_log_bandeja.idMensaje = tbl_mensajes.idMensaje limit 1),0) as idusuariolog"),
                DB::Raw("IFNULL(tbl_log_bandeja.idUsuarioLog,'0') as idusuariolog"),
                DB::RAW("CONCAT(IFNULL(cat_usuarios.nombre,''), ' ', IFNULL(cat_usuarios.apellidoPaterno,'')) as nombreusuario"),
            )
            ->where('tbl_mensajes.eliminado',0)
            ->whereIn('tbl_mensajes.idEstadoMensaje',  [1,6])
            ->where('cat_roles.emergencia',  $veremergencias)
            ->orderBy('tbl_mensajes.idMensaje')
            ->get();

        return $data;
    }
    public static function getMensajesByIDMensajeForBandeja($idMensaje)
    {
        $data = DB::table('tbl_mensajes')
            ->join('tbl_mapas', 'tbl_mapas.idMensaje','=', 'tbl_mensajes.idMensaje')
            //->join('cat_estados_mensajes', 'cat_estados_mensajes.idEstadoMensaje','=', 'tbl_mensajes.idEstadoMensaje')
            ->join('cat_vigilantes','cat_vigilantes.idVigilante', '=', 'tbl_mensajes.idVigilante')
            //->join('tbl_vigilantes_grupos', 'tbl_vigilantes_grupos.idVigilante', '=', 'tbl_mensajes.idVigilante')
            //->join('cat_grupos','cat_grupos.idGrupo', '=', 'tbl_vigilantes_grupos.idGrupo')
            ->join('cat_grupos','cat_grupos.idGrupo', '=', 'tbl_mensajes.idGrupo')
            ->join('cat_municipios','cat_municipios.idMunicipio', '=', 'cat_grupos.idMunicipio')
            /*->join('tbl_grupos_rol', function($join) use($idrol) {
                $join->on('tbl_grupos_rol.idGrupo', '=', 'tbl_mensajes.idGrupo')
                    ->where('tbl_grupos_rol.idRol', '=', $idrol);
            })*/
            //->join('cat_roles', 'cat_roles.idRol','=', 'tbl_grupos_rol.idRol')

            //->leftJoin('tbl_log_bandeja', 'tbl_log_bandeja.idMensaje','=', 'tbl_mensajes.idMensaje')
            //->leftJoin('cat_usuarios', 'cat_usuarios.idUsuario','=', 'tbl_log_bandeja.idUsuarioLog')
            ->leftJoin('tbl_log_bandeja', function ($leftJoin) {
                $leftJoin->on('tbl_log_bandeja.idMensaje', '=', 'tbl_mensajes.idMensaje')
                    ->leftJoin('cat_usuarios', 'cat_usuarios.idUsuario','=', 'tbl_log_bandeja.idUsuarioLog')
                    ->where('tbl_log_bandeja.idLogBandeja', '=', DB::raw("(select max(t2.idLogBandeja) from tbl_log_bandeja as t2 where t2.idMensaje = tbl_mensajes.idMensaje)"));
            })

            ->select(
                'tbl_mensajes.idMensaje as idmensaje',
                'tbl_mensajes.idEstadoMensaje as idestado',
                'tbl_mensajes.mensaje',
                'tbl_mensajes.numeroCelular as numerocelular',
                'tbl_mensajes.mensaje',
                DB::Raw("DATE_FORMAT(tbl_mensajes.fechaRegistro, '%d/%m/%Y %H:%i:%s') as fecharegistro"),
                'tbl_mensajes.folio',
                //'tbl_mensajes.imagen',
                DB::Raw("(select imagen from tbl_imagenes_mensaje where tbl_imagenes_mensaje.idMensaje = tbl_mensajes.idMensaje limit 1) as imagen"),
                'tbl_mensajes.emergencia',

                'tbl_mapas.latitud',
                'tbl_mapas.longitud',
                DB::RAW("IFNULL(tbl_mapas.direccionGoogle,'') as dirGoogle"),

                DB::RAW("CONCAT(cat_vigilantes.nombre, ' ', IFNULL(cat_vigilantes.apellidoPaterno,''), IFNULL(cat_vigilantes.apellidoMaterno,'')) as nombrecompleto"),

                //'cat_estados_mensajes.estadoMensaje as estadomensaje',

                'cat_grupos.siglas as siglasgrupo',
                'cat_municipios.municipio',
                DB::Raw("'0' as idColonia"),
                DB::Raw("'' as colonia"),
                'tbl_mensajes.idGrupo as idgrupo',

                //DB::Raw("'' as idUsuarioLog"),
                //DB::Raw("'' as nombreUsuario"),
                //DB::Raw("IFNULL((select idUsuarioLog from tbl_log_bandeja where tbl_log_bandeja.idMensaje = tbl_mensajes.idMensaje limit 1),0) as idusuariolog"),
                DB::Raw("IFNULL(tbl_log_bandeja.idUsuarioLog,'0') as idusuariolog"),
                DB::RAW("CONCAT(IFNULL(cat_usuarios.nombre,''), ' ', IFNULL(cat_usuarios.apellidoPaterno,'')) as nombreusuario"),
            )
            ->where('tbl_mensajes.eliminado',0)
            //->whereIn('tbl_mensajes.idEstadoMensaje',  [1,6])
            //->where('cat_roles.emergencia',  $veremergencias)
            ->where('tbl_mensajes.idMensaje',  $idMensaje)
            ->orderBy('tbl_mensajes.idMensaje')
            ->first();

        return $data;
    }



    public static function getMensajeByIDMensajeForWebService($idMensaje)
    {
        $data = DB::table('tbl_mensajes')
            ->join('tbl_mapas', 'tbl_mapas.idMensaje','=', 'tbl_mensajes.idMensaje')
            ->join('cat_estados_mensajes', 'cat_estados_mensajes.idEstadoMensaje','=', 'tbl_mensajes.idEstadoMensaje')
            ->join('cat_vigilantes','cat_vigilantes.idVigilante', '=', 'tbl_mensajes.idVigilante')
            ->join('cat_grupos','cat_grupos.idGrupo', '=', 'tbl_mensajes.idGrupo')
            ->join('cat_municipios','cat_municipios.idMunicipio', '=', 'cat_grupos.idMunicipio')
            ->select(
                'tbl_mensajes.idMensaje',
                'tbl_mensajes.idEstadoMensaje',
                'cat_estados_mensajes.estadoMensaje',
                'tbl_mensajes.mensaje',
                'tbl_mensajes.numeroCelular',
                DB::Raw("DATE_FORMAT(tbl_mensajes.fechaRegistro, '%d/%m/%Y %H:%i:%s') AS fechaRegistro"),
                'tbl_mensajes.folio',
                DB::Raw("(SELECT imagen from tbl_imagenes_mensaje where tbl_imagenes_mensaje.idMensaje = tbl_mensajes.idMensaje limit 1) as imagen"),
                'tbl_mensajes.emergencia',
                'tbl_mapas.latitud',
                'tbl_mapas.longitud',
                DB::RAW("IFNULL(tbl_mapas.direccionGoogle,'') as direccionGoogle"),
                'tbl_mapas.referencias',
                DB::RAW("CONCAT(cat_vigilantes.nombre, ' ', IFNULL(cat_vigilantes.apellidoPaterno,''), IFNULL(cat_vigilantes.apellidoMaterno,'')) as vigilante"),
                'cat_grupos.idGrupo',
                'cat_grupos.siglas',
                'cat_municipios.idMunicipio',
                'cat_municipios.municipio'
            )
            ->where('tbl_mensajes.eliminado',0)
            ->where('tbl_mensajes.idMensaje',  $idMensaje)
            ->orderBy('tbl_mensajes.idMensaje')
            ->first();

        return $data;
    }
    public static function getMensajesByIDVigilanteIDGrupoForWebServices($idVigilante,$idGrupo)
    {
        $data = DB::table('tbl_mensajes')
            ->join('tbl_mapas', 'tbl_mapas.idMensaje','=', 'tbl_mensajes.idMensaje')
            ->join('cat_estados_mensajes', 'cat_estados_mensajes.idEstadoMensaje','=', 'tbl_mensajes.idEstadoMensaje')
            ->join('cat_vigilantes','cat_vigilantes.idVigilante', '=', 'tbl_mensajes.idVigilante')
            ->join('cat_grupos','cat_grupos.idGrupo', '=', 'tbl_mensajes.idGrupo')
            ->join('cat_municipios','cat_municipios.idMunicipio', '=', 'cat_grupos.idMunicipio')
            ->select(
                'tbl_mensajes.idMensaje',
                'tbl_mensajes.idEstadoMensaje',
                'cat_estados_mensajes.estadoMensaje',
                'tbl_mensajes.mensaje',
                'tbl_mensajes.numeroCelular',
                DB::Raw("DATE_FORMAT(tbl_mensajes.fechaRegistro, '%d/%m/%Y %H:%i:%s') AS fechaRegistro"),
                'tbl_mensajes.folio',
                DB::Raw("(SELECT imagen from tbl_imagenes_mensaje where tbl_imagenes_mensaje.idMensaje = tbl_mensajes.idMensaje limit 1) as imagen"),
                'tbl_mensajes.emergencia',
                'tbl_mapas.latitud',
                'tbl_mapas.longitud',
                DB::RAW("IFNULL(tbl_mapas.direccionGoogle,'') as direccionGoogle"),
                'tbl_mapas.referencias',
                DB::RAW("CONCAT(cat_vigilantes.nombre, ' ', IFNULL(cat_vigilantes.apellidoPaterno,''), IFNULL(cat_vigilantes.apellidoMaterno,'')) as vigilante"),
                'cat_grupos.idGrupo',
                'cat_grupos.siglas',
                'cat_municipios.idMunicipio',
                'cat_municipios.municipio'
            )
            ->where('tbl_mensajes.eliminado',0)
            ->where('tbl_mensajes.idVigilante',  $idVigilante)
            ->where('tbl_mensajes.idGrupo',  $idGrupo)
            ->orderBy('tbl_mensajes.idMensaje','DESC')
            ->get();


        return $data;
    }


}
