<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\DB;

class Servicio extends Model
{
    use HasFactory;

    protected $table = 'tbl_servicios';
    protected $primaryKey = 'idServicio';

    protected $fillable = [
        'servicio',
        'eliminado'
    ];


    public static function getAllServicios(){

        $servicios = DB::table('tbl_servicios')
            ->select(
                'tbl_servicios.idServicio',
                'tbl_servicios.servicio',
            )
            ->where('tbl_servicios.eliminado',  0)
            ->orderBy('tbl_servicios.idServicio','desc')
            ->paginate(30);


        return $servicios;

    }
    public static function getAllServiciosLike($txtbuscar)
    {
        $servicios = DB::table('tbl_servicios')
            ->select(
                'tbl_servicios.idServicio',
                'tbl_servicios.servicio',
            )
            ->where(function ($query) use ($txtbuscar) {
                $query->where('tbl_servicios.servicio', "LIKE", "%$txtbuscar%")
                    ->where('tbl_servicios.eliminado',  0);
            })
            ->orWhere(function ($query) use ($txtbuscar) {
                $query->where('tbl_servicios.idServicio', "=", $txtbuscar)
                    ->where('tbl_servicios.eliminado', 0);
            })
            ->orderBy('tbl_servicios.idServicio','desc')
            ->paginate(30);

        return $servicios;

    }

}
