﻿
/* CONSTRUCTOR*/

MapaClass = function (Container, idusuario) {

    this.IdContent_   = Container || "map";
    this.MarkersData_ = null;
    this.map          = null;
    this.idUsuario_   = idusuario || null;
    this.ImagesDirection_ = "images/tv30/Markers/";
};

MapaClass.prototype.IdContent_       = null;
MapaClass.prototype.MarkersData_     = null;
MapaClass.prototype.map              = null;
MapaClass.prototype.idUsuario_       = null;
MapaClass.prototype.ImagesDirection_ = null;


/*METODOS MAPA*/

MapaClass.prototype.UploadDataMarkersArray = async function (data) {

    //this.MarkersData_ = new Object();
    this.MarkersData_ = [];

    if (data != null) {
        for (var msj in data) {

            var id    = "Marker" + data[msj].idmensaje;
            var image = this.GetMarkerImage(data[msj].idestado, data[msj].emergencia, data[msj].idusuariolog);

            console.log(id);
            if (this.MarkersData_[id] == null) {
                const { LatLng } = await google.maps.importLibrary("core")
                var location = new LatLng(data[msj].latitud, data[msj].longitud);

                const beachFlagImg = document.createElement("img");
                beachFlagImg.src = image;

                const { AdvancedMarkerElement } = await google.maps.importLibrary("marker");
                const markerElement = new AdvancedMarkerElement({
                    map:      null,
                    position: location,
                    title:    data[msj].idmensaje.toString(),
                    content:  beachFlagImg
                });

                this.MarkersData_[id]       = markerElement;
                this.MarkersData_[id].datos = data[msj];

                this.ShowInfoWindows(this.MarkersData_[id]);
            }
            else {
                bootbox.alert("Ya existe el " + id + " en el arreglo Global de Marcadores del Mapa.");
            }
        }

        this.BuildMap();
    }
    else {
        alert("No hay datos para agregar en el arreglo Global de Marcadores");
    }
}
MapaClass.prototype.BuildMap = async function () {
    const { Map } = await google.maps.importLibrary("maps");
    this.map = new Map(document.getElementById("map"), {
        center: { lat: 16.7542784, lng: -93.1004416 },
        zoom: 13,
        mapId: "ID_MAPA",
        mapTypeId: google.maps.MapTypeId.HYBRID,
        zoomControl: true,
        scaleControl: true,
        fullscreenControl: false,
        rotateControl: true,
        mapTypeControl: true,
        mapTypeControlOptions:
        {
            style: google.maps.MapTypeControlStyle.HORIZONTAL_BAR,
            position: google.maps.ControlPosition.TOP_CENTER
        },
        navigationControl: true,
        navigationControlOptions:
        {
            style: google.maps.NavigationControlStyle.DEFAULT,
            position: google.maps.ControlPosition.LEFT_CENTER
        }
    });
    this.map.setMapTypeId(google.maps.MapTypeId.ROADMAP);


    //Ajustamos el estilo ocultando comercios...
    const styledMapType = new google.maps.StyledMapType(
        [
            {
                featureType: "poi.business",
                stylers: [{ visibility: "off" }],
            },
            /*{
                featureType: "poi",
                elementType: "labels",
                stylers: [{ visibility: "off" }]
            },*/
            /*{
                featureType: "transit",
                elementType: "labels.icon",
                stylers: [{ visibility: "off" }],
            }*/
        ]
    );
    this.map.mapTypes.set('styled_map', styledMapType);
    this.map.setMapTypeId('styled_map');


    //Pintamos los markers...
    this.ShowAllMarkers();
}
MapaClass.prototype.ShowInfoWindows = function (marker) {

    contentString = "<div class='textInfobubble'>";
    contentString += "<div class='rows'>";
    contentString += "<div class='column idmensajeinfobubble'> Mensaje " + marker.datos.idmensaje + "</div>";
    contentString += "<div class='column numerocelularinfobubble'>" + marker.datos.numerocelular + "</div>";
    contentString += "</div>";
    contentString += "<div class='rows'>";
    contentString += "<div class='column Imginfobubble'><img alt='mensaje' src='imagenesmensajes/" + marker.datos.imagen + "' width='100px' height='70px' /></div>";

    contentString += "<div class='column mensajeinfobubble'>"
    contentString += "<a href='#' onclick=\"return abrirVentanaRespuesta(" + marker.datos.idmensaje + ");\" >";
    if (marker.datos.mensaje == "")
    { contentString += "Sin mensaje"; }
    else {
        contentString += marker.datos.mensaje.toString();
    }
    contentString += "</a> "
    contentString += "<i class='fa fa-hand-point-up text-warning icon-clic' onclick=\"return abrirVentanaRespuesta(" + marker.datos.idmensaje + ");\"></i>"
    contentString += "</div>";
    contentString += "</div>";
    contentString += "</div>";

    const infowindow = new google.maps.InfoWindow({
        content: contentString,
        ariaLabel: "Uluru",
    });

    var themap = this.map;
    marker.addListener("click", () => {
        console.log('ShowInfoWindows... ' + marker.datos.idmensaje);

        infowindow.open({
            anchor: marker,
            themap
        });


        //var id    = "Marker2";
        //this.MarkersData_[id].setIcon('http://maps.google.com/mapfiles/ms/icons/blue-dot.png');
        //marker.setIcon('http://maps.google.com/mapfiles/ms/icons/blue-dot.png');



        /*console.log(marker);
        var image = new google.maps.MarkerImage(this.ImagesDirection_+"ubicar.png");
        //marker.setIcon(image);
        this.setIcon({
            url: this.ImagesDirection_+"ubicar.png",
            scaledSize: new google.maps.Size(48, 50)
        });*/
    });

}
MapaClass.prototype.ShowAllMarkers = function () {

    if (this.MarkersData_ != null) {
        for (var msj in this.MarkersData_) {
            this.MarkersData_[msj].setMap(this.map);
        }
    }

}
MapaClass.prototype.addDataMarkerInArray = async function(newData) {

    var data = new Object();
    data = newData;

    if (data != null) {
        for (var msj in data)
        {
            console.log('addDataMarkerInArray... ' + data[msj].idmensaje);

            var id = "Marker" + data[msj].idmensaje;
            var image = this.GetMarkerImage(data[msj].idestado, data[msj].emergencia, data[msj].idusuariolog);

            if (this.MarkersData_[id] == null) {

                /*var Latlng = new google.maps.LatLng(data[msj].latitud, data[msj].longitud);
                var marker = new google.maps.Marker({
                    position: Latlng,
                    map:null,
                    title: data[msj].idmensaje.toString(),
                    icon: image
                });
                this.MarkersData_[id] = marker;
                this.MarkersData_[id].datos = data[msj];

                this.ShowInfoWindows(this.MarkersData_[id]);*/

                const { LatLng } = await google.maps.importLibrary("core")
                var locationLatLng = new LatLng(data[msj].latitud, data[msj].longitud);

                const beachFlagImg = document.createElement("img");
                beachFlagImg.src = image;

                const { AdvancedMarkerElement } = await google.maps.importLibrary("marker");
                const markerElement = new AdvancedMarkerElement({
                    map:      null,
                    position: locationLatLng,
                    title:    data[msj].idmensaje.toString(),
                    content:  beachFlagImg
                });

                this.MarkersData_[id]       = markerElement;
                this.MarkersData_[id].datos = data[msj];

                this.ShowInfoWindows(this.MarkersData_[id]);

            }
            else {
                this.MarkersData_[id].datos.idestado = data[msj].idestado;
             }

        }
    }
    else { alert("No hay datos para la creacion de un Nuevo Marcador"); }
}
MapaClass.prototype.GetOneDataMarkerFromArray = function (idmensaje) {

    console.log('GetOneDataMarkerFromArray... ' + idmensaje);

    var id = "Marker" + idmensaje;
    var data = null;

    if (this.MarkersData_[id] != null) {
        data = this.MarkersData_[id].datos;
    }

    return data;
}
MapaClass.prototype.addMarker = function (newData) {

    var data = new Object();
    data = newData;

    if (data != null) {
        for (var msj in data) {

            var id = "Marker" + data[msj].idmensaje;
            var image = this.GetMarkerImage(data[msj].idestado, data[msj].emergencia, data[msj].idusuariolog);

            if (this.MarkersData_[id] == null) {
                var Latlng = new google.maps.LatLng(data[msj].latitud, data[msj].longitud);
                var marker = new google.maps.Marker({
                    position: Latlng,
                    map: this.map,
                    title: data[msj].idmensaje.toString(),
                    icon: image
                });
                this.MarkersData_[id] = marker;
                this.MarkersData_[id].datos = data[msj];

                this.ShowInfoWindows(this.MarkersData_[id]);
            }
            else
            {
                this.ChangeMarkerStatus(data[msj].idmensaje, data[msj].idestado);
            }

        }
    }
    else { alert("No hay datos para la creacion de un Nuevo Marcador"); }
}
MapaClass.prototype.DeleteMarker = function (idmensaje) {
    if (idmensaje != null) {
        var id = "Marker" + idmensaje;

        if (this.MarkersData_[id] != null) {

            this.MarkersData_[id].setMap(null);
            delete this.MarkersData_[id];

        }
    }

}
MapaClass.prototype.HideAllMarkers = function () {
    if (this.MarkersData_ != null) {
        for (var msj in this.MarkersData_) {
           this.MarkersData_[msj].setMap(null);
        }
    }
}
MapaClass.prototype.ShowOnlyMarkersByOneNumber = function (numero) {

    if (this.MarkersData_ != null) {
        for (var msj in this.MarkersData_) {
            if (this.MarkersData_[msj].datos.numerocelular == numero) {
                this.MarkersData_[msj].setMap(this.map);
            }
            else {
                this.MarkersData_[msj].setMap(null);
             }
        }
    }
}
MapaClass.prototype.ShowOnlyMarkersByOneColonia = function (idcolonia) {

    if (this.MarkersData_ != null) {
        for (var msj in this.MarkersData_) {
            if (this.MarkersData_[msj].datos.idColonia == idcolonia) {
                this.MarkersData_[msj].setMap(this.map);
            }
            else {
                this.MarkersData_[msj].setMap(null);
             }
        }
    }
}
MapaClass.prototype.SearchMarker = async function (idmensaje){

    console.log('SearchMarker... ' + idmensaje);

    var id   = "Marker" + idmensaje;
    var locationLatLon        = new google.maps.LatLng(this.MarkersData_[id].datos.latitud, this.MarkersData_[id].datos.longitud);
    var image= this.ImagesDirection_ + "ubicar.png";


    //Cambiamos el icon  con replace...
    this.ChangeMarkerIcon(idmensaje, image);


    //Centramos en el marker (zoom 18)...
    this.map.setCenter(locationLatLon);
    this.map.setZoom(15);

}
MapaClass.prototype.GetMarkerImage = function (idestado, emergencia, idusuario) {

    var image = "";
    var idstatus = idestado || null;
    var emer = emergencia || null;
    var idusu = idusuario || null;


    //if (this.idUsuario_.toString() != "326") {
        switch (idstatus)
        {
            case "7":                           //Lo han puesto En Atencion C4...(VERDE)74DF00-5FB404-088A08
                if (idusu.toString() != "0") {
                    if (idusu == this.idUsuario_)
                    { image = this.ImagesDirection_ + "enAtencionC4OcupadoMio.png"; }
                    else
                    { image = this.ImagesDirection_ + "enAtencionC4Ocupado.png"; }
                }
                else {
                    image = this.ImagesDirection_ + "enAtencionC4.png";
                }
                break;
            case "8":                            //Lo han puesto en Baja C4...(GRIS)E6E6E6
                if (idusu.toString() != "0") {
                    if (idusu == this.idUsuario_)
                    { image = this.ImagesDirection_ + "msjBajaOcupadoMio.png"; }
                    else
                    { image = this.ImagesDirection_ + "msjBajaOcupado.png"; }
                }
                else {
                    image = this.ImagesDirection_ + "msjBaja.png";
                }
                break;
            case "12":                          //Ya habia sido turnado, y se va a returnar...(AMARILLO)FF8000--(NARANJA)
                if (idusu.toString() != "0") {
                    if (idusu.toString() == this.idUsuario_) {
                        image = this.ImagesDirection_ + "returnadoOcupadoMio.png";
                    }
                    else {
                        image = this.ImagesDirection_ + "returnadoOcupado.png";
                    }
                }
                else {
                    image = this.ImagesDirection_ + "returnado.png";
                }
                break;
            default:
                if (idusu.toString() != "0") {
                    if (idusu.toString() == this.idUsuario_) {
                        image = this.ImagesDirection_ + "nuevoOcupadoMio.png";
                    }
                    else {
                        image = this.ImagesDirection_ + "nuevoOcupado.png";
                    }
                }
                else {
                    image = this.ImagesDirection_ + "nuevo.png";
                }

                if (emer == "True" || emer == "true" || emer == "1" || emer == 1) {
                    if (idusu.toString() != "0") {
                        if (idusu.toString() == this.idUsuario_) {
                            image = this.ImagesDirection_ + "emergenciaOcupadoMio.png";
                        }
                        else {
                            image = this.ImagesDirection_ + "emergenciaOcupado.png";
                        }
                    }
                    else {
                        image = this.ImagesDirection_ + "emergencia.png";
                    }
                }
                break;

        }
    /*}
    else {
        image = this.ImagesDirection_ + "star.png";
    }*/

    console.log('image: '+ image);
    return image;
}
MapaClass.prototype.ChangeMarkerStatus = function (idmensaje, idestado) {

    console.log('ChangeMarkerStatus... ' + idmensaje);

    if (idmensaje != null) {
        var id = "Marker" + idmensaje;
        var idstatus = idestado.toString();

        if (this.MarkersData_[id] != null)
        {
            var idestado         = this.MarkersData_[id].datos.idestado.toString();
            var emergencia       = this.MarkersData_[id].datos.emergencia.toString();
            var idusuario = this.MarkersData_[id].datos.idusuariolog.toString();

            this.MarkersData_[id].datos.idestado = idstatus;

            //this.MarkersData_[id].setIcon(this.GetMarkerImage(idstatus,emergencia,idusuario));
            var image = this.GetMarkerImage(idstatus,emergencia,idusuario);
            this.ChangeMarkerIcon(idmensaje, image);
        }
    }
}
MapaClass.prototype.ChangeMarkerIcon = async function (idmensaje, image) {

    console.log('ChangeMarkerIcon... ' + idmensaje);

    var id= "Marker" + idmensaje;
    var markerDatosRespaldo = this.MarkersData_[id].datos;
    var locationLatLon= new google.maps.LatLng(this.MarkersData_[id].datos.latitud, this.MarkersData_[id].datos.longitud);


    //BORRAMOS EL ACTUAL...
    this.MarkersData_[id].setMap(null);
    this.MarkersData_[id] = null;


    //CREAMOS EL NUEVO MARKER CON LA NUEVA IMAGEN...
    //Add marker in replace...
    const beachFlagImg = document.createElement("img");
    beachFlagImg.src = image;

    const { AdvancedMarkerElement } = await google.maps.importLibrary("marker");
    const markerElement = new AdvancedMarkerElement({
        map:      null,
        position: locationLatLon,
        title:    idmensaje,
        content:  beachFlagImg
    });

    this.MarkersData_[id]       = markerElement;
    this.MarkersData_[id].datos = markerDatosRespaldo;
    this.MarkersData_[id].setMap(this.map);

    this.ShowInfoWindows(this.MarkersData_[id]);
}
MapaClass.prototype.ChangeDisponibility = function (data) {

    var idmensaje = data["0"].idmensaje;
    var id = "Marker" + idmensaje;

    console.log('ChangeDisponibility... ' + idmensaje);
    console.log(this.MarkersData_[id]);

    if (this.MarkersData_[id] != null)
    {
        console.log('ChangeDisponibility ENTRA... ' + idmensaje);

        this.MarkersData_[id].datos.idusuariolog  = data["0"].idusuariolog;
        this.MarkersData_[id].datos.nombreusuario = data["0"].nombreusuario;

        var idestado         = this.MarkersData_[id].datos.idestado.toString();
        var emergencia       = this.MarkersData_[id].datos.emergencia.toString();
        var idusuario = this.MarkersData_[id].datos.idusuariolog.toString();

        var image = this.GetMarkerImage(idestado, emergencia, idusuario)
        //this.MarkersData_[id].setIcon(image);

        //console.log('image again: ' + image);
        this.ChangeMarkerIcon(idmensaje, image);
    }
}
MapaClass.prototype.GoTo = function (idMunicipio) {

    var latitud = "0";
    var longitud = "0";

    if (idMunicipio == "101")          //Tuxtla Gutierrez
    {
        //latitud  = "16.75";
        //longitud = "-93.1166667";
        latitud    = "16.7542784";
        longitud   = "-93.1004416";
    }
    else if (idMunicipio == "78")      // San Cristobal de las Casas
    {
        latitud = "16.737585";
        longitud = "-92.636652";
    }
    else if (idMunicipio == "89")      // Tapachula
    {
        latitud = "14.9";
        longitud = "-92.2666667";
    }

    var myLatlng = new google.maps.LatLng(latitud, longitud);
    this.map.setCenter(myLatlng);
    this.map.setZoom(13);
}
