﻿
// VARIABLES GLOBALES...

let _SERVERPATH;
var MenuBandeja = new MenuClass("cuerpoExtruder");   // Inicializa la Clase MenuClass...
var MapaBandeja = new MapaClass("map");              // Inicializa la Clase MapaClass
//var MapaBandeja;
var fechaUltimaActualizacion;                                            // Contiene la ultima fecha en la que se actualizo la bandeja...
var paramCelular = 0, paramColonia = 0;                 // Parámetros para mostrar la bandeja...
var time;                                                                // Contiene el setimeOut que actualiza a la bandeja...


// VARIABLES GLOBALES RESPUESTA MENSAJE...

var calificacionTotal   = 0;
var MensajeSeleccionado = 0;

// INICIO...

$(document).ready(iniciar);

function iniciar() {
    let path = window.location.pathname;
    _SERVERPATH = "";
    if(path.indexOf("/bandeja/") > -1) {
        let idx = path.indexOf("bandeja/");
        _SERVERPATH = path.substring(0, idx) + "";
    }


    var idUsuario = $("#datosUsuario #idUsuario").val().toString();
    MenuBandeja = new MenuClass("cuerpoExtruder", idUsuario);  // Inicializa la Clase MenuClass
    MapaBandeja = new MapaClass("map", idUsuario);             // Inicializa la Clase MapaClass


    $("#formIdDependencia").change(function () {
        llenarComboCategoria();
    });


    crearMenu();
    obtenerMensajesNuevosBandeja();
    activarFormularioRespuesta();

    addEventCheckbox();


}



// METODOS PRINCIPALES DE BANDEJA...

function crearMenu() {

    $("#extruderRight").buildMbExtruder({
        position: "right",
        width: 350,
        positionFixed: false,
        top: 30,
        extruderOpacity: .8,
        hidePanelsOnClose: true,
        autoCloseTime: 0,
        onExtOpen: function () { },
        onExtContentLoad: function () { },
        onExtClose: function () { }
    });

    $("#extruderRight .flap").empty();
    $("#extruderRight .flap").html("<div><img alt='Mensajes' src='"+_SERVERPATH+"images/tv30/bandeja.png' width='40px'/></div><div id='numMensajes'>Nuevos</div>");

}
function obtenerMensajesNuevosBandeja(idcuenta) {

    var marcaTiempo = new Date().getTime();

    // ENVIAMOS...
    $.ajax({
        async: true,
        type: "GET",
        dataType: "json",
        cache: false,
        contentType: "application/x-www-form-urlencoded",
        url:  _SERVERPATH +'getMensajesEntrantes',
        data: { marcaTiempo: marcaTiempo },
        headers: { 'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content') },
        beforeSend: showIconLoading,
        success: function (data) {
            if (data === "SesionExpired") {  redirectToLogin(); }

            if (data.status === "success") {

                var mensajes = data.mensajes;
                if (mensajes === "SesionExpired") {  redirectToLogin(); }

                MenuBandeja.UploadDataArray(mensajes);
                MenuBandeja.build();

                MapaBandeja.UploadDataMarkersArray(mensajes);
                //MapaBandeja.BuildMap();

                //fechaUltimaActualizacion = MenuBandeja.GetFechaCreacion();
                fechaUltimaActualizacion = $('#fechaHoraServer').val();
                //alert(fechaUltimaActualizacion)

                $("#numMensajes").html(MenuBandeja.GetTotalDataInArray() + "<br/>Nuevos");
                setTimeout('actualizarBandejaMensajes()', 5000);

            }
            else
            {
                bootbox.alert("<strong>¡WARNING!</strong> " + data.msg);
            }
        },
        error: function (datos) {
            //datos = Object {readyState: 4, responseText: "Unauthorized.", status: 401, statusText: "Unauthorized"}
            if (datos.status === 401) {
                bootbox.alert("La sesión ha caducado.");
                document.location = _SERVERPATH + "login"; }
            else {
                bootbox.alert("Ocurrió un error AJAX al intentar guardar los datos.");
            }
        },
        complete: function (xhr, status) {
            hideIconLoading();
        }
    });
}

function actualizarBandejaMensajes() {

    console.log('actualizarBandejaMensajes...');
    clearTimeout(time);

    $.ajax({
        async: true,
        type: "GET",
        dataType: "json",
        contentType: "application/x-www-form-urlencoded",
        url: _SERVERPATH + "getUltimosLogsActualizarBandeja",
        data: { "fechaActualizacion":fechaUltimaActualizacion},
        beforeSend: '',
        success: function (datos) {

            if (datos === "SesionExpired") { redirectToLogin(); }

            var Mensajesrows = datos.logsMensajes;

            var idmensaje;
            var idestado;

            if (Mensajesrows != null) {
                for (var msj in Mensajesrows) {

                    if(Mensajesrows[msj].jsonDisponible !== "-") {

                        //Evalua la disponibilidad por si alguien tiene abierto el reporte...
                        var data = $.parseJSON(Mensajesrows[msj].jsonDisponible);

                        MenuBandeja.ChangeDisponibility(data);
                        MapaBandeja.ChangeDisponibility(data);
                    }
                    else {

                        let idEstadoMensaje = parseInt(Mensajesrows[msj].idEstadoMensaje);

                        if (idEstadoMensaje === 10 || idEstadoMensaje === 2)  // Mensaje Eliminado o Turnado
                        {
                            MenuBandeja.DeleteMsj(Mensajesrows[msj].idMensaje);
                            MapaBandeja.DeleteMarker(Mensajesrows[msj].idMensaje);
                        }
                        else if (idEstadoMensaje === 1 || idEstadoMensaje === 12)  // 1 = Nuevo Mensaje, 12 = Returnado
                        {
                            var newdata = $.parseJSON(Mensajesrows[msj].mensajeJson);
                            console.log('newdata: ' + newdata);

                            if (paramCelular !== 0) {
                                //Se usa cuando se ha filtrado la BE por num celular...
                                if (newdata["0"].numerocelular == paramCelular) {
                                    MenuBandeja.AddNewMsj(newdata);
                                    MapaBandeja.addMarker(newdata);

                                    activarSonido();
                                }
                                else {
                                    MenuBandeja.AddDataInArray(newdata);
                                    MapaBandeja.addDataMarkerInArray(newdata);
                                }
                            }
                            else if (paramColonia !== 0) {
                                //Se usa cuando se ha filtrado la BE por colonia...
                                if (newdata["0"].idColonia == paramColonia) {
                                    MenuBandeja.AddNewMsj(newdata);
                                    MapaBandeja.addMarker(newdata);

                                    activarSonido();
                                }
                                else {
                                    MenuBandeja.AddDataInArray(newdata);
                                    MapaBandeja.addDataMarkerInArray(newdata);
                                }
                            }
                            else {
                                activarSonido();

                                MenuBandeja.AddNewMsj(newdata);
                                MapaBandeja.addMarker(newdata);
                            }
                        }
                        else if (idEstadoMensaje === 7 || idEstadoMensaje === 8) // 7 = Mensaje en Atencion c4, 8 = bajaC4
                        {
                            idmensaje = Mensajesrows[msj].idMensaje;
                            idestado  = Mensajesrows[msj].idEstadoMensaje;

                            MenuBandeja.ChangeStatus(idmensaje, idestado);
                            MapaBandeja.ChangeMarkerStatus(idmensaje, idestado);
                        }
                        else if (idEstadoMensaje === 9) {
                        }
                        else {
                            alert("Mensaje con estado = " + Mensajesrows[msj].idEstadoMensaje);
                        }
                    }

                    fechaUltimaActualizacion = Mensajesrows[msj].fechaRegistro;
                }


                $("#numMensajes").html(MenuBandeja.GetTotalMsjShowing() + "<br/>Nuevos");
            }

            time = setTimeout('actualizarBandejaMensajes()', 5000);
        },
        error: function () {
            bootbox.alert("Error Ajax!!...No se pudo ejecutar obtener lo ultimosLogsActualizarBandeja")
        },
        complete: function (xhr, status) {

        }
    });

    return false;
}
function regresarBandejaMsjNuevos() {
    showIconLoading();

    paramCelular = 0;
    paramColonia = 0;

    MenuBandeja.ShowCompleteData();
    MapaBandeja.ShowAllMarkers();
    MapaBandeja.GoTo(101);

    $("#numMensajes").html(MenuBandeja.GetTotalDataInArray()+ "<br>Nuevos");

    hideIconLoading();
}



// METODOS MENSAJES - RESPUESTA MENSAJE...

function abrirVentanaRespuesta(idMensaje) {

    console.log('abrirVentanaRespuesta...' + idMensaje);
    showLoadingOver();

    $("#modalRegistrarRespuestaTitle").text("Atender Reporte [" + idMensaje + "]");

    //Send push...
    $("#sendPushRespuestaVigilante").attr('checked', true);

    var Mensaje         = MenuBandeja.GetOneDataFromArray(idMensaje);
    var idUsuario            = $("#datosUsuario #idUsuario").val().toString();
    var usuarioPonerAtencion = $("#datosUsuario #userPonerAtencion").val().toString();
    var idrolUsuario         = $("#datosUsuario #idRolUsuario").val().toString();


    if (Mensaje.idusuariolog.toString() === "0" || Mensaje.idusuariolog.toString() === idUsuario)  // Si el Mensaje no está Abierto ó es mío...
    {
        var formData = new FormData();
        formData.append('idMensaje',Mensaje.idmensaje);
        formData.append('tipoEvento',"abrir");

        $.ajax({
            async: true,
            type: "POST",
            dataType: "json",
            cache: false,
            //contentType: "application/x-www-form-urlencoded",
            contentType: false,
            processData: false,
            url: _SERVERPATH + "setMensajeDisponibility",
            data: formData,    // Poner en ocupado
            headers: { 'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content') },
            //beforeSend: showIconLoading(),
            success: function (resultado) {

                if (resultado === "SesionExpired") { redirectToLogin(); }

                if (resultado.status === "success") {
                    if (parseInt(resultado.result) === 1) // Si se ejecutó...
                    {
                        resetVentanaRespuesta();
                        llenarComboDependencias(Mensaje.idgrupo.toString());
                        $("#formIdDependencia").focus();

                        $("#FormularioRespuestaMensaje #formIdMensaje").val(Mensaje.idmensaje);
                        $("#FormularioRespuestaMensaje #formLatitud").val(Mensaje.latitud);
                        $("#FormularioRespuestaMensaje #formLongitud").val(Mensaje.longitud);

                        $("#FormularioRespuestaMensaje #formfolio").val(Mensaje.folio);
                        $("#FormularioRespuestaMensaje #formIdGrupo").val(Mensaje.idgrupo);
                        $("#FormularioRespuestaMensaje #formIdEstadoMsj").val(Mensaje.idestado);
                        $("#FormularioRespuestaMensaje #formFechaRegistro").val(Mensaje.fecharegistro);

                        $("#FormularioRespuestaMensaje #lblNoCel").html(Mensaje.numerocelular);
                        $("#FormularioRespuestaMensaje #lblFechaEnvio").html(Mensaje.fecharegistro.substr(0, 10) + " " + Mensaje.fecharegistro.substr(11, 16));
                        $("#FormularioRespuestaMensaje #lblMensaje").html(Mensaje.mensaje);
                        $("#FormularioRespuestaMensaje #lblNombre").html(Mensaje.nombrecompleto);
                        $("#FormularioRespuestaMensaje #lblGrupo").html(Mensaje.siglasgrupo + " -- ");
                        $("#FormularioRespuestaMensaje #lblCiudad").html(Mensaje.municipio);
                        $("#FormularioRespuestaMensaje #foto img").attr("src", _SERVERPATH + 'imagenesmensajes/' + Mensaje.imagen);


                        if (resultado.jsonreturnado !== "" && resultado.jsonreturnado != null) {

                            var text = $.parseJSON(resultado.jsonreturnado);

                            var clasificacionCategoria = text["0"].clasificacion + " (Cla) / " + text["0"].categoria + " (Cat)";
                            var dependenciafechaseguim = text["0"].dependencia + " - " + text["0"].fechaseguimiento;
                            $("#FormularioRespuestaMensaje #DatosReturnado #ClasificacionCategoriaReturnado").html(clasificacionCategoria);
                            $("#FormularioRespuestaMensaje #DatosReturnado #DependenciaFechaSeguim").html(dependenciafechaseguim);
                            $("#FormularioRespuestaMensaje #DatosReturnado #Seguimiento").html(text["0"].seguimiento);

                            $("#FormularioRespuestaMensaje #DatosReturnado").show();
                        }

                        if (resultado.jsonbaja !== "" && resultado.jsonbaja != null) {

                            var text = $.parseJSON(resultado.jsonbaja);

                            var dependenciafechabaja = text["0"].dependencia + " - " + text["0"].fechaseguimiento;

                            $("#FormularioRespuestaMensaje #DatosBaja #dependenciaFechaBaja").html(dependenciafechabaja);
                            $("#FormularioRespuestaMensaje #DatosBaja #seguimientoBaja").html(text["0"].seguimiento);
                            $("#FormularioRespuestaMensaje #DatosBaja").show();
                        }


                        if (usuarioPonerAtencion === "true" || usuarioPonerAtencion === "True") {
                            $("#FormularioRespuestaMensaje #ChangeStatusArea").show();
                            var ComboAtencion = $("#FormularioRespuestaMensaje #ChangeStatusArea #cmbCambiarStatus");
                            ComboAtencion.empty();

                            if (Mensaje.idestado.toString() === "7") {
                                $("#FormularioRespuestaMensaje #formTxtRespuesta").val("");

                                ComboAtencion.get(0).options[ComboAtencion.get(0).options.length] = new Option("Dar de Baja", "Dar de Baja");
                                ComboAtencion.get(0).options[ComboAtencion.get(0).options.length] = new Option("En Estatus Normal", "En Estatus Normal");
                            } else if (Mensaje.idestado.toString() === "8") {
                                ComboAtencion.get(0).options[ComboAtencion.get(0).options.length] = new Option("En Estatus Normal", "En Estatus Normal");
                            } else {
                                ComboAtencion.get(0).options[ComboAtencion.get(0).options.length] = new Option("En Atencion", "En Atencion");
                            }
                        }
                        if (Mensaje.idestado.toString() === "8") {
                            $("#btnEnviar").hide();
                        }
                        if (idrolUsuario === "3") {
                            $("#btnEliminar").hide();
                        }
                        if (parseFloat(Mensaje.longitud) !== 0) {
                            $("#FormularioRespuestaMensaje #iconUbicar").html("<img title='Ubicar Mensaje' alt='Ubicar Mensaje' src='" + _SERVERPATH + "images/tv30/ubicar.png' onclick=\"javascript:ubicarMensajeMapa('" + Mensaje.idmensaje + "','" + Mensaje.municipio + "','" + Mensaje.colonia + "','" + Mensaje.dirGoogle + "'); return false; \" />");


                        }
                        else {
                            $("#FormularioRespuestaMensaje #iconUbicar").html("");
                        }


                        var idMensajeCompuesto = Mensaje.idmensaje.toString().padStart(10, '0');
                        x = "<img alt='Ocupado'  src='" + _SERVERPATH + "images/tv30/candado_mio.png' width='20px' height='20px' />";
                        $("#Msj" + idMensajeCompuesto + " .BannerMsj .statusatencion").html(x);


                        //ROMPEMOS...
                        $('#modalRegistrarRespuesta').modal('show');

                        hideLoadingOver();
                    }
                    else {
                        bootbox.alert("¡El reporte ya está siendo Atendido por otro usuario!");
                    }
                }
                else
                {
                    bootbox.alert("<strong>¡WARNING!</strong> " + resultado.msg);
                }
            },
            error: function () {
                bootbox.alert("Error Ajax!!...No se puede abrir la Ventana Respuesta")
            },
            complete: function (xhr, status) {
                hideLoadingOver();
            }
        });
    }
    else {
        hideLoadingOver();
        bootbox.alert("¡El reporte ya está siendo Atendido por otro usuario!");
    }

    return false;
}
function cerrarVentanaRespuesta() {

    var idmensaje  = $("#FormularioRespuestaMensaje #formIdMensaje").val();
    //var idestado = $("#FormularioRespuestaMensaje #formIdEstadoMsj").val();

    if (idmensaje != "")
    {
        //var data = "idmensaje=" + idmensaje +"&tipoevento=cerrar";
        var formData = new FormData();
        formData.append('idMensaje', idmensaje);
        formData.append('tipoEvento',"cerrar");

        $.ajax({
            async: true,
            type: "POST",
            dataType: "json",
            cache: false,
            //contentType: "application/x-www-form-urlencoded",
            contentType: false,
            processData: false,
            url: _SERVERPATH + "setMensajeDisponibility",
            data: formData,                                 //Poner en disponible.
            headers: { 'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content') },
            beforeSend: showLoadingOver,
            success: function (data)
            {
                if (data == "SesionExpired") { redirectToLogin(); }

                if (data.status == "success")
                {
                    if (data.result == 1) // Si se ejecutó...
                    {
                        $("#ContenedorMensajes #Msj" + idmensaje + " .BannerMsj .statusatencion").html("");

                        actualizarBandejaMensajes();

                        modalRespuestaClose();
                        hideLoadingOver();

                        return false;
                    }
                    else {
                        bootbox.alert("Error en la Consulta!!...al cerrar la Ventana Respuesta");
                    }
                }
                else
                {
                    bootbox.alert("<strong>¡WARNING!</strong> " + data.msg);
                }
            },
            error: function () {
                bootbox.alert("Error Ajax!!...a la hora de cerrar la Ventana Respuesta")
            },
            complete: function (xhr, status) {
                hideLoadingOver();
            }
        });

    }
    else
    {
        modalRespuestaClose();
    }

    return false;
}
function abrirVentanaStreetView(idmensaje,latitud, longitud) {

    $("#modalStreetViewTitle").html("Vista de Calle [" + idmensaje + "]");

    var src = "http://maps.google.com/maps?layer=c&cbll=" + latitud + "," + longitud + "&cbp=12,242.85,,0,0&ie=UTF8&ll=37.0625,-95.677068&spn=0,79.013672&t=h&z=4&&output=svembed";
    $("#frameStreetView").attr("src", src)
    $("#modalStreetView").modal("show");

    return false;
}
function addEventCheckbox() {

    calificacionTotal = 0;

    $("#ratings span").each(function () {
        var img = $("img", this).attr("alt");
        $(":checkbox", this).attr('checked', false);
        $("img", this).attr("src", _SERVERPATH + "images/tv30/Calificacion/Abstractos/" + img + "Unchecked.png")
        $(":checkbox", this).hide();
    });
    $("#ratings span").hover(
        function () {
            var img = $("img", this).attr("alt");
            $("img", this).attr("src", _SERVERPATH + "images/tv30/Calificacion/Abstractos/" + img + "Hover.png");
        },
        function () {
            var img = $("img", this).attr("alt");
            if ($(":checkbox", this).is(":checked")) {
                $("img", this).attr("src", _SERVERPATH + "images/tv30/Calificacion/Abstractos/" + img + "Checked.png");

            }
            else {
                $("img", this).attr("src", _SERVERPATH + "images/tv30/Calificacion/Abstractos/" + img + "Unchecked.png");
            }


        }
    );
    $("#ratings span").click(function () {

        var img = $("img", this).attr("alt");

        if ($(":checkbox", this).is(":checked")) {
            $(":checkbox", this).attr('checked', false);
            $("img", this).attr("src", _SERVERPATH + "images/tv30/Calificacion/Abstractos/" + img + "Unchecked.png");

            if (img !== "relevante") {
                calificacionTotal = calificacionTotal - 1;
                $("#formCalificacionTotal").val(calificacionTotal);
            }
        }
        else {
            $(":checkbox", this).attr('checked', true);
            $("img", this).attr("src", _SERVERPATH + "images/tv30/Calificacion/Abstractos/" + img + "Checked.png");

            if (img !== "relevante") {
                calificacionTotal = calificacionTotal + 1;
                $("#formCalificacionTotal").val(calificacionTotal);
            }
        }

    });
}
function resetVentanaRespuesta() {

    document.getElementById('FormularioRespuestaMensaje').reset();

    //HIDDEN
    $("#FormularioRespuestaMensaje #formIdMensaje").val("");
    $("#FormularioRespuestaMensaje #formLatitud").val("");
    $("#FormularioRespuestaMensaje #formLongitud").val("");
    $("#FormularioRespuestaMensaje #formfolio").val("");
    $("#FormularioRespuestaMensaje #formIdGrupo").val("");
    $("#FormularioRespuestaMensaje #formIdEstadoMsj").val("");
    $("#FormularioRespuestaMensaje #formIdDependencia").val("");
    //$("#FormularioRespuestaMensaje #formIdClasificacionDep").val("");
    $("#FormularioRespuestaMensaje #formFechaRegistro").val("");

    $("#FormularioRespuestaMensaje #formidColonia").val("0");
    $("#FormularioRespuestaMensaje #formidCallePrincipal").val("0");
    $("#FormularioRespuestaMensaje #formidCalle2").val("0");
    $("#FormularioRespuestaMensaje #formidCalle3").val("0");

    // LABELS
    $("#FormularioRespuestaMensaje #lblNoCel").html("");
    $("#FormularioRespuestaMensaje #lblFechaEnvio").html("");
    $("#FormularioRespuestaMensaje #lblMensaje").html("");
    $("#FormularioRespuestaMensaje #lblNombre").html("");
    $("#FormularioRespuestaMensaje #lblGrupo").html("");
    $("#FormularioRespuestaMensaje #lblCiudad").html("");
    $("#FormularioRespuestaMensaje #foto img").attr("src", "");

    // SELECT
    $("#formIdDependencia").empty();
    $("#formIdCategoria").empty();

    // TEXT
    $("#FormularioRespuestaMensaje #formTxtDependencia").val("");

    // TEXTAREA
    $("#FormularioRespuestaMensaje #formTxtRespuesta").val("ATTE. CENTRO DE MONITOREO");
    $("#FormularioRespuestaMensaje #formTxtMensajeMas").val("");

    // CUENTA CARACTERES
    var noChars = $("#FormularioRespuestaMensaje #formTxtRespuesta").val().length;
    $("#FormularioRespuestaMensaje #InfoCharCounter").html(noChars + " caracteres / 250");

    // BOTONES
    $("#btnEliminar").show();
    $("#btnEnviar").show();
    $("#btnSalirNvoOK").show();

    // CALIFICACION
    calificacionTotal = 0;
    $("#formCalificacionTotal").val(calificacionTotal);
    $("#lblError").hide();
    $("#lblError").html("");

    $("#ratings span").each(function () {
        var img = $("img", this).attr("alt");
        $(":checkbox", this).attr('checked', false);
        $("img", this).attr("src", _SERVERPATH + "images/tv30/Calificacion/Abstractos/" + img + "Unchecked.png")
        $(":checkbox", this).hide();
    });

    // DATOS RETURNADOS

    $("#FormularioRespuestaMensaje #DatosReturnado #ClasificacionCategoriaReturnado").html("");
    $("#FormularioRespuestaMensaje #DatosReturnado #DependenciaFechaSeguim").html("");
    $("#FormularioRespuestaMensaje #DatosReturnado #Seguimiento").html("");
    $("#FormularioRespuestaMensaje #DatosReturnado").hide();

    // DATOS BAJA

    $("#FormularioRespuestaMensaje #DatosBaja #dependenciaFechaBaja").html("");
    $("#FormularioRespuestaMensaje #DatosBaja #seguimientoBaja").html("");
    $("#FormularioRespuestaMensaje #DatosBaja").hide();

    // PONER ATENCION

    $("#FormularioRespuestaMensaje #ChangeStatusArea").hide();
    $("#FormularioRespuestaMensaje #ChangeStatusArea #cmbCambiarStatus").empty();

    // UBICACION MENSAJE

    $("#FormularioRespuestaMensaje #iconUbicar").html("");
    $("#FormularioRespuestaMensaje #DatosUbicacion #formtxtColonia").html("");
    $("#FormularioRespuestaMensaje #DatosUbicacion #formTxtCallePrincipal").val("");
    $("#FormularioRespuestaMensaje #DatosUbicacion #formTxtCalle2").val("");
    $("#FormularioRespuestaMensaje #DatosUbicacion #formTxtCalle3").val("");
    $("#FormularioRespuestaMensaje #DatosUbicacion").hide();

    // EXTRUDER REUBICAR

    $("#datosNuevaUbicacionMapa").hide();
}
function llenarComboDependencias(idGrupo) {
    $.ajax({
        async: true,
        type: "GET",
        dataType: "json",
        contentType: "application/x-www-form-urlencoded",
        //url: "getClasificacionesGrupo",
        url: _SERVERPATH + "getDependenciasGrupo",
        data: { "idGrupo" : idGrupo },
        beforeSend: showLoadingOver(),
        success: function (data)
        {
            if (data == "SesionExpired") { redirectToLogin(); }

            data = data.dependencias;
            var comboControl = $("#formIdDependencia");
            comboControl.empty();

            if (data.length > 0) {
                comboControl.get(0).options[comboControl.get(0).options.length] = new Option("SELECCIONE...", "");
                for (a in data) {
                    comboControl.get(0).options[comboControl.get(0).options.length] = new Option(data[a].dependencia, data[a].idDependencia);
                }
            }

            //Colocamos por default...
            var comboCategoria = $("#formIdCategoria");
            comboCategoria.empty();
            comboCategoria.get(0).options[comboCategoria.get(0).options.length] = new Option("SELECCIONE...", "");

            hideLoadingOver();
        },
        error: function () { alert("No se puedieron extraer las dependencias del idGrupo " + idGrupo) }
    });

    return false;
}
function llenarComboCategoria() {
    var idDependencia = $("#formIdDependencia").val();

    $.ajax({
        async: true,
        type: "GET",
        dataType: "json",
        contentType: "application/x-www-form-urlencoded",
        url: _SERVERPATH + "getCategoriasDependencia",
        data: { "idDependencia":idDependencia },
        beforeSend: showLoadingOver(),
        success: function (data) {

            if (data == "SesionExpired") { redirectToLogin(); }

            data = data.categorias;
            var comboControl = $("#formIdCategoria");
            comboControl.empty();

            if (data.length > 0) {
                comboControl.get(0).options[comboControl.get(0).options.length] = new Option("SELECCIONE...", "");
                for (a in data) {
                    comboControl.get(0).options[comboControl.get(0).options.length] = new Option(data[a].categoria, data[a].idCategoria);
                }
            }

            hideLoadingOver();
        },
        error: function () {
            alert("No se pudieron extraer las categorías de la idDependencia " + idDependencia);
        }
    });

    return false;
}
function chekKeyCaracteresEsp(evento) {

    if (typeof (evento.charCode) != "undefined")
        var elchar = String.fromCharCode(evento.charCode).toUpperCase();    //Firefox, Safari
    else
        var elchar = String.fromCharCode(evento.keyCode).toUpperCase();     //IE, Opera

    var caracteres = "ABCDEFGHIJKLMNÑOPQRSTUVWXYZ 1234567890()$/*+.,-_#?¡¿!";
    var noChars = $("#FormularioRespuestaMensaje #formTxtRespuesta").val().length;

    if (noChars >= 250) {
        //$("#FormularioRespuestaMensaje #InfoCharCounter").html(noChars + " caracteres / 2 SMS");
        //evento.keyCode = 0;
        return;
    }
    else {
        //$("#FormularioRespuestaMensaje #InfoCharCounter").html(noChars + " caracteres / 1 SMS");
        $("#FormularioRespuestaMensaje #InfoCharCounter").html(noChars + " caracteres / 250");
    }

    //Definir si el codigo de la tecla oprimida esta en la lista
    var teclaValida;
    if (caracteres.indexOf(elchar) == -1) {
        teclaValida = false;
        if (typeof (evento.charCode) != "undefined") {
            //evento.charCode = 0;
        }
        else
            evento.keyCode = 0;
    }
    else {
        teclaValida = true;
        if (typeof (evento.charCode) != "undefined") {
            //evento.charCode = String.fromCharCode(evento.charCode).toUpperCase().charCodeAt(0);
        }
        else
            evento.keyCode = String.fromCharCode(evento.keyCode).toUpperCase().charCodeAt(0);
    }
}
function activarFormularioRespuesta() {

    console.log('activarFormularioRespuesta...');

    var Formulario = $("#FormularioRespuestaMensaje");

    Formulario.validate({
        errorClass: "invalid-feedback",
        validClass: "has-success",
        errorElement: "span",
        errorPlacement: function(error, element) {
            if(element.parent('.input-group').length || element.parent('.custom-checkbox').length) {
                error.insertAfter(element.parent());
            }
            else if(element.closest('.input-custom').length){
                error.insertAfter(element.parent());
            }
            else {
                error.insertAfter(element);
            }
        },
        highlight: function(element) {
            $(element).closest('.form-control').addClass('is-invalid');
        },
        unhighlight: function(element) {
            $(element).closest('.form-control').removeClass('is-invalid');
        },
        submitHandler: function (form) {

            if (parseInt(calificacionTotal) > 0) {

                bootbox.confirm("La respuesta se enviará, ¿desea continuar?", function (result) {
                    if(result) {

                        let formIdMensaje               = $("#FormularioRespuestaMensaje #formIdMensaje").val();
                        let formIdEstadoMsj             = $("#FormularioRespuestaMensaje #formIdEstadoMsj").val();
                        let formIdDependencia           = $("#FormularioRespuestaMensaje #formIdDependencia").val();
                        let formIdCategoria             = $("#FormularioRespuestaMensaje #formIdCategoria").val();
                        let formTxtMensajeMas           = $("#FormularioRespuestaMensaje #formTxtMensajeMas").val();
                        let formTxtRespuesta            = $("#FormularioRespuestaMensaje #formTxtRespuesta").val();

                        let withfoto                    = $("#withFoto").is(":checked");
                        let withkeyword                 = $("#withKeyword").is(":checked");
                        let withdescription             = $("#withDescription").is(":checked");
                        let withdirecciontext           = $("#withDireccionText").is(":checked");
                        let withexactlydirectionMap     = $("#withExactlyDirectionMap").is(":checked");
                        let isrelevant                  = $("#isRelevant").is(":checked");
                        let formCalificacionTotal       = $("#formCalificacionTotal").val();
                        let sendPushRespuestaVigilante  = $("#sendPushRespuestaVigilante").is(":checked");

                        let latitud                     = $("#FormularioRespuestaMensaje #formLatitud").val();
                        let longitud                    = $("#FormularioRespuestaMensaje #formLongitud").val();
                        let idcolonia                   = $("#FormularioRespuestaMensaje #formidColonia").val();
                        let idcalle1                    = $("#FormularioRespuestaMensaje #formidCallePrincipal").val();
                        let idcalle2                    = $("#FormularioRespuestaMensaje #formidCalle2").val();
                        let idcalle3                    = $("#FormularioRespuestaMensaje #formidCalle3").val();
                        let calle1                      = $("#FormularioRespuestaMensaje #DatosUbicacion #formTxtCallePrincipal").val();
                        let calle2                      = $("#FormularioRespuestaMensaje #DatosUbicacion #formTxtCalle2").val();
                        let calle3                      = $("#FormularioRespuestaMensaje #DatosUbicacion #formTxtCalle3").val();


                        let formData = new FormData();
                        formData.append("formIdMensaje", formIdMensaje);
                        formData.append("formIdEstadoMsj", formIdEstadoMsj);
                        formData.append("formIdDependencia", formIdDependencia);
                        formData.append("formIdCategoria", formIdCategoria);
                        formData.append("formTxtMensajeMas", formTxtMensajeMas);
                        formData.append("formTxtRespuesta", formTxtRespuesta);

                        formData.append("withFoto", withfoto);
                        formData.append("withKeyword", withkeyword);
                        formData.append("withDescription", withdescription);
                        formData.append("withDireccionText", withdirecciontext);
                        formData.append("withExactlyDirectionMap", withexactlydirectionMap);
                        formData.append("isRelevant", isrelevant);
                        formData.append("formCalificacionTotal", formCalificacionTotal);
                        formData.append("sendPushRespuestaVigilante", sendPushRespuestaVigilante);

                        formData.append("formlatitud", latitud);
                        formData.append("formlongitud", longitud);
                        formData.append("formidcolonia", idcolonia);
                        formData.append("formidcalle1", idcalle1);
                        formData.append("formidcalle2", idcalle2);
                        formData.append("formidcalle3", idcalle3);
                        formData.append("formcalle1", calle1);
                        formData.append("formcalle2", calle2);
                        formData.append("formcalle3", calle3);



                        $.ajax({
                            async: true,
                            type: "POST",
                            dataType: "json",
                            //contentType: "application/x-www-form-urlencoded",
                            contentType: false,
                            processData: false,
                            url: Formulario.attr("action"),
                            data: formData,
                            headers: { 'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content') },
                            beforeSend: showLoadingOver,
                            success: function (data) {
                                if (data === "SesionExpired") { redirectToLogin(); }

                                if (data.status === "success") {
                                    modalRespuestaClose();
                                    hideLoadingOver();
                                    bootbox.alert("La respuesta ha sido enviada exitosamente.");
                                }
                                else {
                                    bootbox.alert("La respuesta no ha sido enviada. " + data.msg);
                                }
                            },
                            error: function () {
                                bootbox.alert(data.msg);
                            },
                            complete: function (xhr, status) {

                            }
                        });
                    }
                });
            }
            else {
                    $("#lblError").show();
                    $("#lblError").html("La respuesta no tiene calificación. Verifíquelo por favor.");
                    bootbox.alert("La respuesta no tiene calificación. Verifíquelo por favor.");
            }
        },
        rules:
        {
            formIdDependencia:  { required: true },
            formIdCategoria:    { required: true },
            formTxtRespuesta:   { required: true }
        },
        messages:
        {
            formIdDependencia:  { required: "*Requerido" },
            formIdCategoria:    { required: "*Requerido" },
            formTxtRespuesta:   { required: "*Requerido" }
        }
    });
}
function eliminarMensaje() {

    let formIdMensaje               = $("#FormularioRespuestaMensaje #formIdMensaje").val();
    let formTxtRespuesta            = $("#FormularioRespuestaMensaje #formTxtRespuesta").val();

    if (formTxtRespuesta !== ""){
        bootbox.confirm("¿Esta seguro que desea eliminar el mensaje?", function (result) {
            if(result) {



                let formData = new FormData();
                formData.append("_method", 'delete');
                formData.append("formIdMensaje", formIdMensaje);
                formData.append("formTxtRespuesta", formTxtRespuesta);

                $.ajax({
                    async: true,
                    type: "POST",
                    dataType: "json",
                    //contentType: "application/x-www-form-urlencoded",
                    contentType: false,
                    processData: false,
                    url: 'eliminarMensaje',
                    data: formData,
                    headers: { 'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content') },
                    beforeSend: showLoadingOver,
                    success: function (data) {
                        if (data === "SesionExpired") { redirectToLogin(); }

                        if (data.status === "success") {
                            modalRespuestaClose();
                            hideLoadingOver();
                        }
                        else {
                            bootbox.alert("El mensaje no ha sido eliminado. " + data.msg);
                        }
                    },
                    error: function () {
                        bootbox.alert(data.msg);
                    },
                    complete: function (xhr, status) {

                    }
                });

            }


        });
    }


    else {

        $("#lblError").show();
        $("#lblError").html("El mensaje no tiene respuesta.");
    }

}
function modalRespuestaClose() {
    resetVentanaRespuesta();
    $("#modalRegistrarRespuesta").modal("hide");

}



// METODOS SECUNDARIOS...

function searchMsjInBandeja(idmensaje) {
    MenuBandeja.SearchMsj(idmensaje);
}
function ubicarMensajeMapa(idmensaje, municipio, colonia, dirgoogle) {

    if (MensajeSeleccionado != 0 && MensajeSeleccionado != idmensaje)
    {
        var data= MapaBandeja.GetOneDataMarkerFromArray(MensajeSeleccionado);
        if (data != null && data != "null" && data != "") {
            MapaBandeja.ChangeMarkerStatus(data.idmensaje, data.idestado);
        }
    }

    setTimeout(2000);

    MensajeSeleccionado = idmensaje;
    MapaBandeja.SearchMarker(idmensaje);

    showDatosMsjUbicado(municipio,colonia,dirgoogle);
}
function showDatosMsjUbicado(municipio, colonia, dirgoogle) {
    $("#ContenedorMapa #ciudad").text(municipio);
    $("#ContenedorMapa #colonia").text(colonia);
    $("#ContenedorMapa #dirGoogle").text(dirgoogle);

    $("#ContenedorMapa #fondodatosUbicacionMsj").slideDown();
    $("#ContenedorMapa #datosUbicacionMsj").slideDown();
}



//  EXTRAS...

function showIconLoading() { $('#loading').show(); }
function hideIconLoading() { $('#loading').hide(); }
function showUpload() { $('#UploadRespuesta').show(); }
function hideUpload() { $('#UploadRespuesta').hide(); }
function showLoadingOver() { $('#loadingOver').show(); }
function hideLoadingOver() { $('#loadingOver').hide(); }
function redirectToLogin() {
    window.location.href = _SERVERPATH + "login";
}
function activarSonido() {
    document.getElementById('audiotag1').play(); }
