@extends('layouts.template_01')

@section('title', 'Accesar')

@section('content')
    <section class="py-5">
        <div class="container">
            <div class="row justify-content-center">
                <div class="col-md-8 col-lg-6">

                    @if (session('status'))
                        <div class="alert alert-success alert-dismissible fade show" role="alert">
                            {!! session('status')  !!}
                            <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
                        </div>
                    @endif
                    @if (session('status_success'))
                        <div class="alert alert-success" role="alert">
                            {!! session('status_success')  !!}
                        </div>
                    @endif
                    @if (session('status_fail'))
                        <div class="alert alert-danger" role="alert">
                            {!! session('status_fail')  !!}
                        </div>
                    @endif

                    @if($errors->any())
                        <div class="alert alert-danger" role="alert">
                            <ul>
                                @foreach($errors->all() as $error)
                                    <li class="alert-link">{{$error}}</li>
                                @endforeach
                            </ul>
                        </div>
                        <br/>
                    @endif


                    {!! Form::open(['url'=>'login','method' => 'POST', 'id'=>'FormRegister','class'=>'contact-form'])!!}

                    <div class="card rounded-3 mt-5 card-opacity">
                        <div class="card-body">
                            <div class="text-center mb-5">
                                <img src="{{asset('images/logos/logoVoz01.png')}}" class="img-fluid" style="max-width: 200px; margin: 0 auto;" alt="Voz Ciudadana" />
                            </div>

                            <div class="mb-3">
                                {!! Form::label('email', 'Email:',['class'=>'sr-only']) !!}
                                <input id="email" type="email" class="form-control form-control-lg {{ $errors->has('email') ? ' is-invalid' : '' }}" name="email" value="{{ old('email') }}" placeholder="Correo Electronico" required autofocus>
                                @if ($errors->has('email'))
                                    <span class="invalid-feedback" role="alert">
                                                <strong>{{ $errors->first('email') }}</strong>
                                            </span>
                                @endif
                            </div>

                            <div class="mb-3">
                                {!! Form::label('password', 'Password:',['class'=>'sr-only']) !!}
                                <input id="password" type="password" class="form-control form-control-lg {{ $errors->has('password') ? ' is-invalid' : '' }}" name="password" placeholder="Contraseña" required>
                                @if ($errors->has('password'))
                                    <span class="invalid-feedback" role="alert">
                                        <strong>{{ $errors->first('password') }}</strong>
                                    </span>
                                @endif
                            </div>

                            <div class="form-check mb-4">
                                <input class="form-check-input" type="checkbox" value="" id="remember" name="remember">
                                <label class="form-check-label" for="remember">
                                    Recordarme
                                </label>
                            </div>

                            <div class="mb-3">
                                <button type="submit" class="btn btn-dark w-100">Accesar</button>
                            </div>

                        </div>
                    </div>

                    {!! Form::close()!!}

                </div>
            </div>
        </div>
    </section>

@endsection


@section('scripts')

@endsection

