<!DOCTYPE html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <link rel="icon" type="image/png" href="{{asset('images/favicon/favicon-96x96.png')}}" sizes="96x96" />
    <link rel="icon" type="image/svg+xml" href="{{asset('images/favicon//favicon.svg')}}" />
    <link rel="shortcut icon" href="{{asset('images/favicon/favicon.ico')}}" />
    <link rel="apple-touch-icon" sizes="180x180" href="{{asset('images/favicon/apple-touch-icon.png')}}" />
    <link rel="manifest" href="{{asset('images/favicon/site.webmanifest')}}" />

    <title>Voz Ciudadana</title>

    <x-default_metas/>

    <x-default_fonts/>

    <x-default_styles/>

    <link href="{{asset('css/custom.css')}}" rel="stylesheet">

    @yield('css')

</head>
<body class="font-sans antialiased">

<div id="loading" class="preloader">
    <div class="spinner-border text-primary" role="status">
        <span class="sr-only">Loading...</span>
    </div>
</div>
<nav class="navbar navbar-expand-lg border-bottom border-body" data-bs-theme="dark">
    <div class="container-fluid">
        <!--<a class="navbar-brand" href="{{asset('/')}}">
           <img src="{{asset('images/logos/logo_horizontal_white.png')}}" class="img-fluid" alt="Eloisa Gómez"  />
        </a>-->

        <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
            <span class="navbar-toggler-icon"></span>
        </button>
        <div class="collapse navbar-collapse" id="navbarSupportedContent">
            <ul class="navbar-nav ms-auto mb-2 mb-lg-0">
                <!--<li class="nav-item">
                    <a class="nav-link active" aria-current="page" href="{{asset('/')}}">Inicio</a>
                </li>-->

                @guest
                    <!--<li class="nav-item">
                        <a class="nav-link" href="{{route('login')}}">Iniciar Sesión</a>
                    </li>-->
                @else
                    <li class="nav-item dropdown">
                        <a class="nav-link dropdown-toggle" href="#" role="button" data-bs-toggle="dropdown" aria-expanded="false">
                            {{ Auth::user()->nombre }} {{ Auth::user()->apellidoPaterno }}
                        </a>
                        <ul class="dropdown-menu">
                            <li>
                                <a class="dropdown-item" href="{{ route('logout') }}" onclick="event.preventDefault(); document.getElementById('logout-form').submit();">Cerrar Sesión</a>
                                <form id="logout-form" action="{{ route('logout') }}" method="POST"
                                      style="display: none;">
                                    @csrf
                                </form>
                            </li>
                        </ul>
                    </li>
                @endguest
            </ul>
        </div>
    </div>
</nav>

@yield('content')

<footer class="footer">
    <div class="container">
        <div class="row">
            <div class="col-lg-12 text-center text-md-end my-1">
                <p class="m-0 small text-white"><small>MisionMed © @php echo \Carbon\Carbon::now()->year @endphp Copyright Derechos Reservados</small></p>
            </div>
        </div>
    </div>
</footer>

@yield('modal')

<x-default_scripts/>

<script src="{{asset('js/template_01.js')}}"></script>

@yield('javascript')

</body>
</html>
