<!DOCTYPE html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="csrf-token" content="{{ csrf_token() }}">

    <link rel="icon" type="image/png" href="{{asset('images/favicon/favicon-96x96.png')}}" sizes="96x96" />
    <link rel="icon" type="image/svg+xml" href="{{asset('images/favicon//favicon.svg')}}" />
    <link rel="shortcut icon" href="{{asset('images/favicon/favicon.ico')}}" />
    <link rel="apple-touch-icon" sizes="180x180" href="{{asset('images/favicon/apple-touch-icon.png')}}" />
    <link rel="manifest" href="{{asset('images/favicon/site.webmanifest')}}" />

    <title>VC - @yield('title')</title>

    <x-default_metas/>

    <x-default_fonts/>

    <x-default_styles/>

    <link href="{{asset('css/TV/reset.css')}}" rel="stylesheet">
    <link href="{{asset('css/TV/Global.css')}}" rel="stylesheet">

    @yield('css')

</head>
<body class="font-sans antialiased">

<div id="loading" class="preloader">
    <div class="spinner-border" role="status">
        <span class="sr-only">Loading...</span>
    </div>
</div>
<div id="loadingOver">
    <i class="fa fa-circle-notch fa-spin"></i><br/>
</div>


@yield('content')


<footer class="footer">
    <div class="container">
        <div class="row">
            <div class="col-lg-12 text-center text-md-endX my-2">
                <p class="m-0 small text-white">© @php echo \Carbon\Carbon::now()->year @endphp Copyright Derechos Reservados</p>
            </div>
        </div>
    </div>
</footer>


@yield('modal')


<x-default_scripts/>
<script src="{{asset('js/template_01.js')}}"></script>

@yield('javascript')


</body>
</html>
