@extends('layouts.template_01')

@section('css')

@endsection

@section('content')
    <section>
        <div class="container-fluid">
            <div class="row">
                <div class="col">
                    <nav id="breadcrumb"  aria-label="breadcrumb" class="mt-2 mb-5">
                        <ol class="breadcrumb">
                            <li class="breadcrumb-item"><a href="{{asset('inicio')}}">Inicio</a></li>
                            <li class="breadcrumb-item"><a href="{{asset('usuarios')}}">Usuarios</a></li>
                            <li class="breadcrumb-item active" aria-current="page">Nuevo</li>
                        </ol>
                    </nav>
                </div>
            </div>
        </div>
    </section>


    <section id="data-result">
        <div class="container">
            @if (session('status_success'))
                <div class="alert alert-success" role="alert">
                    {!! session('status_success')  !!}
                </div>
            @endif
            @if (session('status_fail'))
                <div class="alert alert-danger" role="alert">
                    {!! session('status_fail')  !!}
                </div>
            @endif

             @if($errors->any())
             <div class="alert alert-danger" role="alert">
                        <ul>
                            @foreach($errors->all() as $error)
                                <li class="alert-link">{{$error}}</li>
                            @endforeach
                        </ul>
                    </div>
                    <br/>
            @endif

        </div>
    </section>

    <section class="py-5">
        <div class="container">
            <div class="row justify-content-center">
                <div class="col-md-10 col-lg-8">

                    {!! Form::open(['url'=>'usuarios','method' => 'POST', 'id'=>'FormNuevoUsuario', 'class'=>''])!!}

                    <div class="card rounded-3">
                        <div class="card-body">
                            <div class="row justify-content-center section-heading">
                                <div class="col-lg-8 col-xl-7 text-center">
                                    <h3 class="h1 after-50 primary-after pb-3 mb-0">Nuevo Usuario</h3>
                                </div>
                            </div>

                            <div class="row mb-3">
                                <div class="col-md-5">
                                    {!! Form::label('idRol', 'Rol:',['class'=>'sr-only']) !!}
                                    {!!Form::select('idRol',$rolesList,null, ['class' => 'form-control','placeholder'=>"SELECCIONE ROL"])!!}
                                </div>
                            </div>
                            <div class="row mb-3">
                                <div class="col-md-12">
                                    {!! Form::label('nombre', 'Nombre:',['class'=>'sr-only']) !!}
                                    {!! Form::text('nombre',null,['class'=>'form-control','placeholder'=>"Nombre"]) !!}
                                </div>
                            </div>

                            <div class="row mb-3">
                                <div class="col-md-6">
                                    {!! Form::label('apellidoPaterno', 'Apellido Paterno:',['class'=>'sr-only']) !!}
                                    {!! Form::text('apellidoPaterno',null,['class'=>'form-control','placeholder'=>"Apellido Paterno"]) !!}
                                </div>
                                <div class="col-md-6">
                                    {!! Form::label('apellidoMaterno', 'Apellido Materno:',['class'=>'sr-only']) !!}
                                    {!! Form::text('apellidoMaterno',null,['class'=>'form-control','placeholder'=>"Apellido Materno"]) !!}
                                </div>
                            </div>

                            <h4 class="my-4">Credenciales de Acceso</h4>

                            <div class="row mb-3">
                                <div class="col-md-8">
                                    {!! Form::label('email', 'Email:',['class'=>'sr-only']) !!}
                                    {!! Form::text('email',null,['class'=>'form-control', 'placeholder'=>'Email']) !!}
                                </div>
                            </div>
                            <div class="row mb-3">
                                <div class="col-md-6">
                                    {!! Form::label('password', 'Password:',['class'=>'sr-only']) !!}
                                    {!! Form::text('password',null,['class'=>'form-control', 'placeholder'=>'Contraseña']) !!}
                                </div>
                                <div class="col-md-6">
                                    {!! Form::label('password_confirmation', 'Confirmar Password:',['class'=>'sr-only']) !!}
                                    {!! Form::text('password_confirmation',null,['class'=>'form-control', 'placeholder'=>'Confirmar Contraseña']) !!}
                                </div>
                            </div>

                            <div class="text-end mt-5">
                                {!! Form::submit('GUARDAR', ['id'=>'btnGuardar','class' => 'btn btn-dark btn-lg w-100']) !!}
                            </div>

                        </div>
                    </div>

                    {!! Form::close()!!}

                    @if($errors->any())
                        <div class="space10"></div>
                        <div class="alert alert-danger" role="alert">
                            <ul>
                                @foreach($errors->all() as $error)
                                    <li class="alert-link">{{$error}}</li>
                                @endforeach
                            </ul>
                        </div>
                        <br/>
                    @endif
                </div>
            </div>
        </div>
    </section>


@endsection

@section('javascript')
    <script src="{{ asset('js/usuarios/usuarios_create.js') }}"></script>
@endsection

