@extends('layouts.template_01')

@section('content')
    <section>
        <div class="container-fluid">
            <div class="row">
                <div class="col">
                    <nav id="breadcrumb"  aria-label="breadcrumb" class="mt-2 mb-5">
                        <ol class="breadcrumb">
                            <li class="breadcrumb-item"><a href="{{asset('inicio')}}">Inicio</a></li>
                            <li class="breadcrumb-item active" aria-current="page">Usuarios</li>
                        </ol>
                    </nav>
                </div>
            </div>
        </div>
    </section>



    <section id="title-section" class="title-section text-center">
        <div class="container">
            <h2>USUARIOS</h2>
        </div>
    </section>

    <section id="content-section" class="content-section">
        <div class="container">
            <div id="search" class="row justify-content-center mb-5">
                <div class="col-md-10">
                    <form method="GET" action="{{asset('usuarios')}}" accept-charset="UTF-8">
                        <div class="input-group input-group-lg">
                            <input type="text" id="txtBuscar" name="txtBuscar" class="form-control" placeholder="Buscar..." aria-label="Buscar post..." aria-describedby="button-addon2" value="{{$txtBuscar}}">
                            <button class="btn btn-lg btn-dark" type="submit" id="button-addon2"><i class="fa fa-fw fa-search fa-lg"></i></button>
                        </div>
                    </form>
                    <small class="total-results float-right"> {{$usuarios->total()}} Registros Encontrados</small>
                </div>
                <div class="col-md-2">
                    <a class="btn btn-dark btn-lg" href="{{asset('usuarios/create')}}" data-toggle="tooltip" data-placement="top" title="" data-original-title="Agregar Post"><i class="fa fa-plus"></i></a>
                </div>
            </div>

            @if (session('status_success'))
                <div class="alert alert-success" role="alert">
                    {!! session('status_success')  !!}
                </div>
            @endif
            @if (session('status_fail'))
                <div class="alert alert-danger" role="alert">
                    {!! session('status_fail')  !!}
                </div>
            @endif


            <div class="row">
                <div class="col-sm-12">
                    <div class="panel-result">
                        <table class="table">
                            <thead>
                                <tr class="table-dark">
                                    <th scope="col">Usuario</th>
                                    <th scope="col">Rol</th>
                                    <th scope="col">Email</th>
                                    <th scope="col">Password</th>
                                    <th scope="col">Acciones</th>
                                </tr>
                            </thead>
                            <tbody>
                                @foreach($usuarios as $usuario)
                                <tr>
                                    <td style="width: 300px;">[{{$usuario->idUsuario}}]  {{$usuario->nombre}} {{$usuario->apellidoPaterno}} {{$usuario->apellidoMaterno}}  </td>
                                    <td>{{$usuario->rol}}</td>
                                    <td>{{$usuario->email}}</td>
                                    <td>{{$usuario->passwordVisible}}</td>


                                    <td>
                                        <a href="{{asset('usuarios/'.$usuario->idUsuario.'/edit_password')}}" class="btn btn-info" data-toggle="tooltip" data-placement="top" title="Cambiar Password">
                                            <i class="fas fa-key" aria-hidden="true"></i>
                                        </a>


                                        <a href="{{asset('usuarios/'.$usuario->idUsuario.'/edit')}}" class="btn btn-dark" data-toggle="tooltip" data-placement="top" title="Editar">
                                            <i class="fas fa-pencil-alt"></i>
                                        </a>

                                        {!! Form::open(['url'=>'usuarios/'.$usuario->idUsuario,'method' => 'DELETE','class'=>'formDeleteEvento','style'=>'display:inline']) !!}
                                        <button type="button" class="btn btn-danger btnDelete" title="Eliminar">
                                            <i class="fas fa-trash-alt"></i>
                                        </button>
                                        {!! Form::close() !!}
                                    </td>
                                </tr>
                                @endforeach
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>

            <div class="row" style="margin-bottom:70px;">
                <div class="col-sm-12 text-center">
                    {!! $usuarios->appends(['txtBuscar' => $txtBuscar])->links()!!}
                </div>
            </div>
        </div>
    </section>
@endsection


@section('javascript')

    <script src="{{ asset('js/usuarios/usuarios_index.js') }}"></script>
@endsection

