<?php

use App\Http\Controllers\BandejaEntradaController;
use App\Http\Controllers\UsuarioController;
use Illuminate\Support\Facades\Route;



Route::get('usuarios', [UsuarioController::class, 'index']);
Route::get('usuarios/create', [UsuarioController::class, 'create']);
Route::post('usuarios', [UsuarioController::class, 'store']);
Route::get('usuarios/{idUsuario}/edit', [UsuarioController::class, 'edit']);
Route::patch('usuarios/{idUsuario}', [UsuarioController::class, 'update']);

Route::get('usuarios/{idUsuario}/edit_password', [UsuarioController::class, 'edit_password']);
Route::patch('usuarios/{idUsuario}/update_password', [UsuarioController::class, 'update_password']);

Route::delete('usuarios/{idUsuario}', [UsuarioController::class, 'destroy']);



/*
|--------------------------------------------------------------------------
| BANDEJA DE ENTRADA
|--------------------------------------------------------------------------
*/

Route::get('/', [BandejaEntradaController::class, 'indexBandeja']);
Route::get('/bandeja', [BandejaEntradaController::class, 'indexBandeja']);

Route::get('getMensajesEntrantes', [BandejaEntradaController::class, 'getMensajesEntrantes']);
Route::post('setMensajeDisponibility', [BandejaEntradaController::class, 'setMensajeDisponibility']);
Route::get('getUltimosLogsActualizarBandeja', [BandejaEntradaController::class, 'getUltimosLogsActualizarBandeja']);
Route::get('getDependenciasGrupo', [BandejaEntradaController::class, 'getDependenciasGrupo']);
Route::get('getCategoriasDependencia', [BandejaEntradaController::class, 'getCategoriasDependencia']);
Route::post('storeRespuestaMensaje', [BandejaEntradaController::class, 'storeRespuestaMensaje']);

Route::delete('eliminarMensaje', [BandejaEntradaController::class, 'eliminarMensaje']);
Route::get('storeMensajeTmp', [BandejaEntradaController::class, 'storeMensajeTmp']);
Route::get('testPush', [BandejaEntradaController::class, 'testPush']);

require __DIR__.'/auth.php';
